#include <iostream>
#include <queue>

using namespace std;

struct cube
{
	int front;
	int back;
	int top;
	int right;
	int bottom;
	int left;
};

struct cell
{
	int enabled, n, sum;
	cube cube_state;
};

struct field
{
	int x, y;
	field(){x = 0; y = 0;}
};

int cube_start_x, cube_start_y, cube_end_x, cube_end_y;

cube rotate_up(cube c)
{
	int s = c.top;
	c.top = c.front;
	c.front = c.bottom;
	c.bottom = c.back;
	c.back = s;
	return c;
}

cube rotate_left(cube c)
{
	int s = c.top;
	c.top = c.right;
	c.right = c.bottom;
	c.bottom = c.left;
	c.left = s;
	return c;
}

cube rotate_right(cube c)
{
	int s = c.top;
	c.top = c.left;
	c.left = c.bottom;
	c.bottom = c.right;
	c.right = s;
	return c;
}

cube rotate_down(cube c)
{
	int s = c.top;
	c.top = c.back;
	c.back = c.bottom;
	c.bottom = c.front;
	c.front = s;
	return c;
	
	return c;
}

int main()
{
	cell table[28][28];
	cube start;
	char input[20];
	
	for (int i = 0; i < 28; i++)
	{
		for (int j = 0; j < 28; j++)
		{
			table[i][j].enabled = 0;
		}
	}
	
	for (int i = 1; i < 27; i++)
	{
		for (int j = 1; j < 27; j++)
		{
			table[i][j].enabled = 1;
			table[i][j].n = -1;
			table[i][j].sum = 0;
		}
	}
	
	cin.get(input[0]);
	cube_start_x = (int)(input[0] - 'a') + 1;
	cin.get(input[0]);
	cube_start_y = (int)(input[0] - '0');
	
	
	
	cin.get(input[0]);
	
	if (input[0] != ' ')
	{
		cube_start_y = 27 -(cube_start_y*10 + (int)(input[0] - '0'));
		cin.get(input[0]);
	}
	else
	{
		cube_start_y = 27 - cube_start_y;
	}
	
	//cout << "vavedeni start! " << (char)(cube_start_x + (int)('a') - 1) << 27 - (cube_start_y) << endl;
	
	cin.get(input[0]);
	cube_end_x = (int)(input[0] - 'a') + 1;
	cin.get(input[0]);
	cube_end_y = (int)(input[0] - '0');
	
	cin.get(input[0]);
	
	if (input[0] != ' ')
	{
		cube_end_y = 27 -(cube_end_y*10 + (int)(input[0] - '0'));
	}
	else
	{
		cube_end_y = 27 - cube_end_y;
	}
	
	//cout << "vavedeni end! " << (char)(cube_end_x + (int)('a') - 1) << 27 - (cube_end_y) << endl;
	/*start.front = (int)(input[6] - '0');
	start.back = (int)(input[8] - '0');
	start.top = (int)(input[10] - '0');
	start.right = (int)(input[12] - '0');
	start.bottom = (int)(input[14] - '0');
	start.left = (int)(input[16] - '0');*/
	
	cin >> start.front >> start.back >> start.top >> start.right >> start.bottom >> start.left;
	
	//cout << start.front << start.back << start.top << start.right << start.bottom << start.left << endl;
	
	table[cube_start_y][cube_start_x].cube_state = start;
	table[cube_start_y][cube_start_x].n = 0;
	table[cube_start_y][cube_start_x].sum = start.bottom;
	
	int f;
	cin >> f;
	
	//cin.getline(input, 20);

	
	for (int i = 0; i < f; i++)
	{
		cin.getline(input, 20);
		//cout << " 1 " << endl;
		cin.get(input[0]);
		//cout << " 2 " << endl;
		cin.get(input[1]);
		//cout << " 3 " << endl;
		table[27 - (int)(input[1] - '0')][(int)(input[0] - 'a') + 1].enabled = 0;
		
		//cout << "vavedeni! " << 27 - (int)(input[1] - '0') << " "<< (int)(input[0] - 'a') + 1 << endl;
	}
	
	int ss = -1;
	int n = 0;
	queue<field> q;
	field s;
	s.x = cube_start_x;
	s.y = cube_start_y;
	q.push(s);
	
	while (!q.empty())
	{
		n++;
		//cout << "vdigame n = " << n << endl;;
		int size = q.size();
		field elem;
		
		for (int i = 0; i < size; i++)
		{
			elem = q.front();
			q.pop();
			
			if ((elem.x == cube_end_x) && (elem.y == cube_end_y))
			{
				ss = table[elem.y][elem.x].sum;
				
				while (!q.empty())	q.pop();
				break;
			}
			
			//cout << "popnat e "  << (char)(elem.x + (int)('a') - 1) << 27 - elem.y << endl;
			//system("pause");
			
			if (/*(table[elem.y-1][elem.x].n == -1) && */(table[elem.y-1][elem.x].enabled))
			{
				if (table[elem.y-1][elem.x].n == -1)
				{
					table[elem.y-1][elem.x].n = n;
					table[elem.y-1][elem.x].cube_state = rotate_up(table[elem.y][elem.x].cube_state);
					table[elem.y-1][elem.x].sum = table[elem.y-1][elem.x].cube_state.bottom + table[elem.y][elem.x].sum;
					
					//cout << "sumata na "  << (char)(elem.x + (int)('a') - 1) << 27 - (elem.y - 1) << " e " << table[elem.y-1][elem.x].sum << endl;
					//system("pause");
					
					field a;
					a.x = elem.x;
					a.y = elem.y-1;
					q.push(a);
					
					//cout << "pushnat e "  << (char)(a.x + (int)('a') - 1) << 27 - a.y << endl;
					//system("pause");
				}
				else
				{
					if ((table[elem.y-1][elem.x].n == n) && (table[elem.y-1][elem.x].sum > table[elem.y][elem.x].sum + table[elem.y][elem.x].cube_state.back))
					{
						table[elem.y-1][elem.x].cube_state = rotate_up(table[elem.y][elem.x].cube_state);
						table[elem.y-1][elem.x].sum = table[elem.y][elem.x].sum + table[elem.y][elem.x].cube_state.back;
						
						//cout << "sumata na "  << (char)(elem.x + (int)('a') - 1) << 27 - (elem.y - 1) << " e podobrena na" << table[elem.y-1][elem.x].sum << endl;
						//system("pause");
						
						/*field a;
						a.x = elem.x;
						a.y = elem.y-1;
						q.push(a);*/
						
						//cout << "pushnat e "  << (char)(a.x + (int)('a') - 1) << 27 - a.y << endl;
						//system("pause");
					}
				}
			}
			if (/*(table[elem.y+1][elem.x].n == -1) && */(table[elem.y+1][elem.x].enabled))
			{
				if (table[elem.y+1][elem.x].n == -1)
				{
					table[elem.y+1][elem.x].n = n;
					table[elem.y+1][elem.x].cube_state = rotate_down(table[elem.y][elem.x].cube_state);
					table[elem.y+1][elem.x].sum=table[elem.y+1][elem.x].cube_state.bottom + table[elem.y][elem.x].sum;
					
					//cout << "sumata na "  << (char)(elem.x + (int)('a') - 1) << 27 - (elem.y + 1) << " e " << table[elem.y+1][elem.x].sum << endl;
					//system("pause");
					
					field a;
					a.x = elem.x;
					a.y = elem.y+1;
					q.push(a);
					
					//cout << "pushnat e "  << (char)(a.x + (int)('a') - 1) << 27 - a.y << endl;
					//system("pause");
				}
				else
				{
					if ((table[elem.y+1][elem.x].n == n) && (table[elem.y+1][elem.x].sum > table[elem.y][elem.x].sum + table[elem.y][elem.x].cube_state.front))
					{
						table[elem.y+1][elem.x].cube_state = rotate_down(table[elem.y][elem.x].cube_state);
						table[elem.y+1][elem.x].sum = table[elem.y][elem.x].sum + table[elem.y][elem.x].cube_state.front;
						
						//cout << "sumata na "  << (char)(elem.x + (int)('a') - 1) << 27 - (elem.y + 1) << " e podobrena na" << table[elem.y+1][elem.x].sum << endl;
						//system("pause");
						
						/*field a;
						a.x = elem.x;
						a.y = elem.y+1;
						q.push(a);*/
						
						//cout << "pushnat e "  << (char)(a.x + (int)('a') - 1) << 27 - a.y << endl;
						//system("pause");
					}
				}
			}
			if (/*(table[elem.y][elem.x-1].n == -1) && */(table[elem.y][elem.x-1].enabled))
			{
				if (table[elem.y][elem.x-1].n == -1)
				{
					table[elem.y][elem.x-1].n = n;
					table[elem.y][elem.x-1].cube_state = rotate_left(table[elem.y][elem.x].cube_state);
					table[elem.y][elem.x-1].sum=table[elem.y][elem.x-1].cube_state.bottom + table[elem.y][elem.x].sum;
					
					//cout << "sumata na "  << (char)(elem.x + (int)('a') - 2) << 27 - (elem.y) << " e " << table[elem.y][elem.x-1].sum << endl;
					//system("pause");
					
					field a;
					a.x = elem.x-1;
					a.y = elem.y;
					q.push(a);
					
					//cout << "pushnat e "  << (char)(a.x + (int)('a') - 1) << 27 - a.y << endl;
					//system("pause");
				}
				else
				{
					if ((table[elem.y][elem.x-1].n == n) && (table[elem.y][elem.x-1].sum > table[elem.y][elem.x].sum + table[elem.y][elem.x].cube_state.left))
					{
						table[elem.y][elem.x-1].cube_state = rotate_left(table[elem.y][elem.x].cube_state);
						table[elem.y][elem.x-1].sum = table[elem.y][elem.x].sum + table[elem.y][elem.x].cube_state.left;
						
						//cout << "sumata na "  << (char)(elem.x + (int)('a') - 2) << 27 - (elem.y) << " e podobrena na" << table[elem.y][elem.x-1].sum << endl;
						//system("pause");
						
						/*field a;
						a.x = elem.x-1;
						a.y = elem.y;
						q.push(a);*/
						
						//cout << "pushnat e "  << (char)(a.x + (int)('a') - 1) << 27 - a.y << endl;
						//system("pause");
					}
				}
			}
			if (/*(table[elem.y][elem.x+1].n == -1) && */(table[elem.y][elem.x+1].enabled))
			{
				if (table[elem.y][elem.x+1].n == -1)
				{
					table[elem.y][elem.x+1].n = n;
					table[elem.y][elem.x+1].cube_state = rotate_right(table[elem.y][elem.x].cube_state);
					table[elem.y][elem.x+1].sum=table[elem.y][elem.x+1].cube_state.bottom + table[elem.y][elem.x].sum;
					
					//cout << "sumata na "  << (char)(elem.x + (int)('a')) << 27 - (elem.y) << " e " << table[elem.y][elem.x+1].sum << endl;
					//system("pause");
					
					field a;
					a.x = elem.x+1;
					a.y = elem.y;
					q.push(a);
					
					//cout << "pushnat e "  << (char)(a.x + (int)('a') - 1) << 27 - a.y << endl;
					//system("pause");
				}
				else
				{
					if ((table[elem.y][elem.x+1].n == n) && (table[elem.y][elem.x+1].sum > table[elem.y][elem.x].sum + table[elem.y][elem.x].cube_state.right))
					{
						table[elem.y][elem.x+1].cube_state = rotate_right(table[elem.y][elem.x].cube_state);
						table[elem.y][elem.x+1].sum = table[elem.y][elem.x].sum + table[elem.y][elem.x].cube_state.right;
						
						//cout << "sumata na "  << (char)(elem.x + (int)('a')) << 27 - (elem.y) << " e podobrena na" << table[elem.y][elem.x+1].sum << endl;
						//system("pause");
						
						/*field a;
						a.x = elem.x+1;
						a.y = elem.y;
						q.push(a);*/
						
						//cout << "pushnat e "  << (char)(a.x + (int)('a') - 1) << 27 - a.y << endl;
						//system("pause");
					}
				}
			}
		}
	}
	
	cout << ss << endl;
	
	//system("pause");
	return 0;
}
